{% extends '_base_layout.html' %}

{% from '_macro/fileupload/macro_layout.html' import fileupload_bs4row_css with context %}
{% from '_macro/fileupload/macro_script.html' import fileupload_bs4row_js with context %}


{% block style %}
{{ fileupload_bs4row_css() }}
{% endblock style %}

{% block content %}
    <div class="render_as_htmlcontrol container-fluid">
    NOTE fileupload control will be appended here
    </div>

    <div style="margin-top:2rem"></div>

    <div class="render_as_htmlcontrol__static">
        <div class="container">
            <div class="row fileupload" id="{{ elemid }}">
                <div class="col-lg-3 col-xs-12">static html of uploader</div>

                <!--region render file w/ thumb -->
                <!--region png-->
                <div class="thumb_border">
                    <div class="file_thumb"
                       {#style="background-image: url('{{ url_for('static', filename='img/namgivu.png') }}' )" #}
                         style="background-image: url('{{ dataurl(                   'img/namgivu.png') }}' )"
                    >
                        <div class="del_thumb"> <i class="fa fa-trash" aria-hidden="true"></i> </div>
                    </div>
                </div>

                <div class="thumb_border">
                    <div class="file_thumb"
                       {#style="background-image: url('{{ url_for('static', filename='img/namgivu2.png') }}' )" #}
                         style="background-image: url('{{ dataurl(                   'img/namgivu2.png') }}' )"
                    >
                        <div class="del_thumb"> <i class="fa fa-trash" aria-hidden="true"></i> </div>
                    </div>
                </div>
                <!--endregion png-->

                <!--region pdf-->
                <div class="thumb_border">
                    <div class="file_thumb"
                         style="background-image: url('{{ url_for('static', filename='img/file-pdf-regular.svg')}}' ); background-size: unset"
                         dataurl="{{ dataurl('pdf/namgivu.pdf') }}"
                    >
                        <div class="del_thumb"> <i class="fa fa-trash" aria-hidden="true"></i> </div>
                    </div>
                </div>
                <!--endregion pdf-->

                <!--endregion render file w/ thumb -->

                <div class="thumb_border add_new_file">
                    <div class="file_thumb uploader_thumb"> <i class="fa fa-upload" aria-hidden="true"></i> </div>

                    <input class="uploader_fileformfield" type="file" style="display: none">
                </div>
            </div>
        </div>
    </div>

    <div style="margin-top:.1rem"></div>

    <div class="render_as_text">
        <pre data-owner="owner0">NOTE owner0 fileuploader rendered here</pre>

        <div style="margin-top:1rem"></div>

        <pre data-owner="owner1">NOTE owner1 fileuploader rendered here</pre>

        <div style="margin-top:1rem"></div>

        <pre id="output_respjson">
            ajax request's result will be printed here
        </pre>
    </div>

{% endblock content %}


{% block js %}
    <script>
        //region call api and render result
        function list_file(owner) {
            $.ajax({
                method: 'GET', url: `{{ API_URL }}/fileupload/byowner/${owner}`,
            }).done(function(data){
                //region output as text

                // set maxlen at :dataurl
                var d = JSON.parse(JSON.stringify(data))  // js deepcopy ref. https://stackoverflow.com/a/5344074/248616
                    d.forEach(e => { e.dataurl = e.dataurl.substring(0,33)+'...  ' } )

                //region print :data as string :s
                {# we can just print JSON.stringify(data) but that will be on oneline urgly #}
                var s = ''
                d.forEach(e => {
                    let t = JSON.stringify(e)  // js obj to str to append to html tag
                    s += `\n${t}`
                })
                s = `\n\n--- owner=${owner}\n${s}`
                //endregion print :data as string :s

                $(`pre[data-owner="${owner}"]` ).html(s)
                //endregion output as text

                render_fileupload_control(filelist=data, owner=owner)
            }).fail(function(jqXHR, textStatus) {
                alert('err') ; throw new Error(textStatus)
            })
        }

        function ping() {
            $.ajax({
                url: '{{ API_URL }}/ping',
            }).done(function(data){
                $('#output_respjson').html(data)
            }).fail(function(jqXHR, textStatus) {
                alert('err') ; throw new Error(textStatus)
            })
        }
        //endregion call api and render result

        $(function(){
            $.when(
                ping(),
                list_file(owner='owner0'),
                list_file(owner='owner1'),
            )
        })
    </script>

    <!--region render api response as html control ie fileupload control -->
    {{ fileupload_bs4row_js() }}
    <script>
        $('.render_as_htmlcontrol').html('')  // clear to append later

        function render_fileupload_control(filelist, owner) {
                                         const html = filelist_to_html(filelist, owner)
            $('.render_as_htmlcontrol').append(html)
        }

    </script>
    <!--endregion render api response as html control ie fileupload control -->

{% endblock js %}
